# Detect the distribution in use
%global __despace /usr/bin/head -n 1 | /usr/bin/tr -d '[:space:]' | %{__sed} -e 's/[(].*[)]//g'
%global __lower4 /usr/bin/cut -c 1-4 | /usr/bin/tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(%{__sed} -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(%{__sed} -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS & White Box as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "wbel"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

%{!?perl_vendorarch: %global perl_vendorarch %(eval "`%{__perl} -V:installvendorarch`"; echo $installvendorarch)}
%{!?__id_u: %global __id_u %([ -x /bin/id ]&&echo /bin/id||([ -x /usr/bin/id ]&&echo /usr/bin/id||echo /bin/true)) -u}

Summary:	GNU Readline XS library wrapper
Name:		perl-Term-ReadLine-Gnu
Version:	1.20
Release:	3.%{__distinit}%{__distvers}
License:	GPL+ or Artistic
Group:		Development/Libraries
URL:		http://search.cpan.org/dist/Term-ReadLine-Gnu/
Source0:	http://search.cpan.org/CPAN/authors/id/H/HA/HAYASHI/Term-ReadLine-Gnu-%{version}.tar.gz
Patch0:		perl-Term-ReadLine-Gnu-1.20-malloc.patch
Patch2:		Term-ReadLine-Gnu-1.17-local.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires:	expect, readline-devel, ncurses-devel, perl(ExtUtils::MakeMaker)
Requires:	perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))

# Don't "provide" private Perl libs, and filter out docfile dependencies
%global _use_internal_dependency_generator 0
%global docfilt %{__perl} -p -e 's|%{_docdir}/%{name}-%{version}\\S+||'
%global so_filt %{__grep} -v '%{perl_vendorarch}/.*\\.so$'
%global __deploop() while read FILE; do /usr/lib/rpm/rpmdeps -%{1} ${FILE}; done | /bin/sort -u
%global __find_provides /bin/sh -c "%{so_filt} | %{__deploop P}"
%global __find_requires /bin/sh -c "%{docfilt} | %{__deploop R}"

%description
Term::ReadLine::Gnu (TRG) is an implementation of the interface to the GNU
Readline Library. This module gives you input line editing facility, input
history management facility, word completion facility, etc. It uses the real
GNU Readline Library and has the interface with the almost all variables and
functions that are documented in the GNU Readline/History Library. So you can
program your custom editing function, your custom completion function, and so
on with Perl. TRG may be useful for a C programmer to prototype a program that
uses the GNU Readline Library.

%prep
%setup -q -n Term-ReadLine-Gnu-%{version}

# Fix for CPAN RT#37194 (CPAN RT#56500) in 1.20 requires perl >= 5.8.6
# so we need to revert it for older perls and use our original patch instead.
# 1.20 also breaks F-9's 5.10.0 perl with different symptoms, so revert
# the fix for perl < 5.10.1.
%if %(perl -e 'print $] >= 5.010001 ? 0 : 1;')
%patch0 -p1 -b .malloc
%endif

# We don't have perl in /usr/local/bin
%patch2 -p1

%build
%{__perl} Makefile.PL INSTALLDIRS=vendor OPTIMIZE="%{optflags}"
# Kludge to remove rpaths (needed for distros < FC2)
%{__perl} -pi -e 's/^\tLD_RUN_PATH=[^\s]+\s*/\t/' Makefile
%{__make} %{?_smp_mflags}

%check
# Expect is used so that we get a PTY, as if we were
# in a real terminal, where readline works
LANG=C expect -c '
	spawn %{__make} test
	expect eof
	exit [lindex [wait] 3]
'

%clean
%{__rm} -rf %{buildroot}

%install
%{__rm} -rf %{buildroot}
%{__make} pure_install PERL_INSTALL_ROOT=%{buildroot}
/usr/bin/find %{buildroot} -type f -name .packlist -exec %{__rm} -f {} ';'
/usr/bin/find %{buildroot} -type f -name '*.bs' -a -size 0 -exec %{__rm} -f {} ';'
/usr/bin/find %{buildroot} -depth -type d -exec /bin/rmdir {} ';' 2>/dev/null
%{__chmod} -R u+w %{buildroot}

%files
%defattr(-,root,root,-)
%doc eg README
%{perl_vendorarch}/Term/
%{perl_vendorarch}/auto/Term/
%{_mandir}/man3/Term::ReadLine::Gnu.3pm*

%changelog
* Thu Jun 24 2010 Paul Howarth <paul@city-fan.org> 1.20-3
- Rebuild for perl 5.12.1 in Rawhide

* Sun May 30 2010 Paul Howarth <paul@city-fan.org> 1.20-2
- Fix dist tag for RHEL-6 Beta

* Mon May  3 2010 Paul Howarth <paul@city-fan.org> 1.20-1
- Update to 1.20
  - Copy environment to avoid segfaults on some systems e.g. FreeBSD
  - Skip the test of rl_readline_version for GNU Readline Library 6.1
  - readline-6.1 support: (func rl_free_keymap, var rl_filename_rewrite_hook)
- Revert environment segfault fix with perl < 5.10.1 and use our patch instead

* Fri Mar  5 2010 Paul Howarth <paul@city-fan.org> 1.19-2
- Make requires/provides filters simpler and more generic
- Kill bogus RPATHs for distros prior to FC-2
- Dist tag for Rawhide no longer needs special-casing

* Mon Mar 23 2009 Paul Howarth <paul@city-fan.org> 1.19-1
- Update to 1.19 (ensure the outstream fd inside the readline library is in
  sync - http://bugs.debian.org/236018; various test fixes)
- Drop visible bell test patch, no longer needed

* Fri Mar  6 2009 Paul Howarth <paul@city-fan.org> 1.18-1
- Update to 1.18
- * better error checking of Makefile.PL
- * readline-6.0 support
- Filter out unwanted provides for perl shared objects
- Change bogus dependency filtering mechanism to tie in with provides filter
- Update to SLES-compatible dist tag macros
- No longer need to fix up permissions in %%prep

* Wed Jul  2 2008 Paul Howarth <paul@city-fan.org> 1.17a-2
- Add Lubomir Rintel's workaround from Fedora for perl 5.10.0 build issues
  (#453287, http://rt.perl.org/rt3/Ticket/Display.html?id=56500)
  Should not be needed when Bug #453646 is fixed
- Run test suite in an "expect" wrapper (add buildreq expect, can now
  include t/readline.t again) so we get a pseudo-terminal
- Add Lubomir Rintel's patch to disable visible bell test, which fails on
  perl 5.10.0
- Tweak dist tag macros to work on current Rawhide with three-part releasenum
- Don't need buildreq bc (where did that come from?)

* Fri Feb  8 2008 Paul Howarth <paul@city-fan.org> 1.17a-1
- Update to 1.17a
- Clarify license as GPL version 1 or later, or Artistic (i.e. same as perl)
- Don't run t/readline.t test since it's interactive
- Update patch to fix references to /usr/local/bin/perl

* Wed Jun  6 2007 Paul Howarth <paul@city-fan.org> 1.16-3
- Fix dist tag for Fedora 7 onwards
- Add buildreq perl(ExtUtils::MakeMaker)
- Fix argument order for find with -depth

* Fri Sep  1 2006 Paul Howarth <paul@city-fan.org> 1.16-2
- Fix distribution tags for development releases
- Define %%{__id_u} in a more portable way
- Further simplify bogus dependency filter
- Don't use macros in build-time command paths, hardcode them instead
- Carry on if tests fail (can't read /dev/tty in mock on FC5 onwards)
- Add buildreq ncurses-devel

* Tue Apr  4 2006 Paul Howarth <paul@city-fan.org> 1.16-1
- Update to 1.16
- Remove buildroot unconditionally in %%clean and %%install
- Own directories properly
- Simplify distribution-detection
- Remove %%__perl_vendorlib macro, not used
- Remove %%__perl_version macro, used only once
- Remove %%__perl_package macro, used only twice
- Use search.cpan.org URLs
- Simplify compiler optimization flag setting
- Simplify filtering of bogus dependencies

* Fri Jun 24 2005 Paul Howarth <paul@city-fan.org> 1.15-3
- Rewrite spec file in (mainly) Fedora Extras style
- Include full URL for source
- Fix URL
- Use MODULE_COMPAT dependency style and remove explicit perl dependency
- Include README and examples

* Thu Dec  2 2004 Paul Howarth <paul@city-fan.org> 1.15-2
- Run "make test" with LANG=C to avoid problems with readline 4.3

* Wed Oct 27 2004 Paul Howarth <paul@city-fan.org> 1.15-1
- Update to 1.15
- Tidy up spec file

* Thu Apr 15 2004 Paul Howarth <paul@city-fan.org> 1.14-3
- Added explicit perl dependency to ensure that an RPM built on a
  system with an updated version of perl (and hence having files
  installed in a place that a non-updated system won't find them)
  will not install on the non-updated system. In such cases, just
  rebuild from the source RPM.
- Changed distribution-identifying macros for greater portability.

* Mon Feb 16 2004 Paul Howarth <paul@city-fan.org> 1.14-2
- Unified spec file for Red Hat and Fedora Core

* Fri Dec 12 2003 Paul Howarth <paul@city-fan.org> 1.14-1.fc1
- More macros
- Expanded description
- Add Fedora Core version to RPM release ID

* Wed Nov 26 2003 Paul Howarth <paul@city-fan.org> 1.14-1
- Update to 1.14
- Patch modules to remove hardcoded references to /usr/local/bin/perl

* Mon Nov 24 2003 Paul Howarth <paul@city-fan.org>
- Tweak for Fedora

* Sat Oct 26 2002 R P Herrold <herrold@owlriver.com.com>
- Fork and re-config from Chip Turner's <cturner@redhat.com> 
  .spec for perl-Date-Calc.spec
